<?php

/************************************************************************/
/* Copyright Russell McGuire 2001-2006                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Podcast Functions                                      */
/*                                                                      */
/*----------------------------------------------------------------------*/
/* Podcast functions - functions used to create and update podcasts     */
/*                     and RSS feeds                                    */
/*                                                                      */
/*----------------------------------------------------------------------*/
/*                                                                      */
/* update_podcast() - Updates the podcast file to include all audio     */
/*                    sermons for this church.                          */
/*                                                                      */
/*----------------------------------------------------------------------*/
/*                                                                      */
/* update_feed() - Updates the feed file to include all                 */
/*                    sermons for this church.                          */
/*                                                                      */
/************************************************************************/

/************************************************************************/
/*                                                                      */
/* UPDATE THIS INFORMATION FOR YOUR CHURCH                              */
/*                                                                      */
/************************************************************************/
$church_name = "Your Church";
$church_url = "http://www.lstones.com"; /* enter your church's web address */


function update_podcast($podcastfile)
	{ 
	global $church_name, $church_url;
	if($pod = fopen($podcastfile,"w"))
		{
		fwrite($pod,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");

		fwrite($pod,"<rss xmlns:itunes=\"http://www.itunes.com/dtds/podcast-1.0.dtd\" ".
				"version=\"2.0\">\n\n");

 

		fwrite($pod,"<channel>\n");

		fwrite($pod,"<ttl>60</ttl>\n");

		fwrite($pod,"<title>$church_name</title>\n");

		fwrite($pod,"<link>".$church_url."</link>\n");

		fwrite($pod,"<language>en-us</language>\n");

		fwrite($pod,"<copyright>&#x2117; &amp; &#xA9; ".date("Y").
				" $church_name</copyright>\n");

		fwrite($pod,"<itunes:subtitle>$church_name Sermons</itunes:subtitle>\n");

		fwrite($pod,"<itunes:author>$church_name</itunes:author>\n");

		fwrite($pod,"<itunes:summary>Sermons from $church_name\n</itunes:summary>\n");

		fwrite($pod,"<itunes:explicit>clean</itunes:explicit>\n");

		fwrite($pod,"<description>This is where sermons from $church_name are broadcast".
				"</description>\n");

		fwrite($pod,"<itunes:owner>\n");

		fwrite($pod,"<itunes:name>$church_name</itunes:name>\n");

		fwrite($pod,"<itunes:email>russ.mcguire@seek-first.com</itunes:email>\n");

		fwrite($pod,"</itunes:owner>\n");

		fwrite($pod,"<itunes:image href=\"http://www.lstones.com/LivingStones.gif\" />\n");

		fwrite($pod,"<itunes:category text=\"Religion &amp; Spirituality\">\n");

		fwrite($pod,"<itunes:category text=\"Christianity\" />\n");

		fwrite($pod,"</itunes:category>\n\n");

		
		/* now get all published sermons with audio files */
		$query = "SELECT uploadurl,ls_sermons.title,sermondate,synopsis,fullname,ls_sermons.id,filesize ".
			"FROM ls_sermon_files,ls_sermons,ls_pastors WHERE uploadtype='Audio' AND ".
			"ls_sermons.id = ls_sermon_files.sermonid AND published>0 AND ".
			"ls_pastors.id = ls_sermons.pastor ORDER BY sermondate DESC";
		$result = sql_getresult($query);

		while($row=sql_getrow($result))
			{
 			fwrite($pod,"<item>\n");
	
			fwrite($pod,"<title>".stripslashes($row[1])."</title>\n");
	
			fwrite($pod,"<itunes:author>".stripslashes($row[4])."</itunes:author>\n");
	
			fwrite($pod,"<itunes:summary>\n".stripslashes($row[3])."\n</itunes:summary>\n");
	
			fwrite($pod,"<enclosure url=\"".stripslashes($row[0]).
				"\" length=\"".$row[6]."\" type=\"audio/mpeg\" />\n");
	
			fwrite($pod,"<guid>".stripslashes($row[0])."</guid>\n");

			fwrite($pod,"<pubDate>".date("D, j M Y",strtotime($row[2]))." 10:30:00 CST</pubDate>\n");
	
			fwrite($pod,"<itunes:keywords>");

			/* get topics */
			$q2 = "SELECT topic FROM ls_sermon_topics WHERE sermonid='$row[5]'";
			$re2 = sql_getresult($q2);
			if($ro2 = sql_getrow($re2))
				fwrite($pod, stripslashes($ro2[0]));
			while($ro2 = sql_getrow($re2))
				fwrite($pod, ", ".stripslashes($ro2[0]));
			fwrite($pod,"</itunes:keywords>\n");
	
			fwrite($pod,"</item>\n\n");
			} /* end while looping through sermon audio files */

		fwrite($pod,"</channel>\n");

		fwrite($pod,"</rss>\n");
		} /* end if opened podcast file */
	} /* end of update_podcast function */

function update_feed($feedfile,$sermonfile)
	{ 
	global $church_name, $church_url;
	if($feed = fopen($feedfile,"w"))
		{
		fwrite($feed,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		fwrite($feed,"<?xml-stylesheet href=\"http://feeds.feedburner.com/~d/styles/rss2full.xsl\" ".
			"type=\"text/xsl\" media=\"screen\"?>\n");
		fwrite($feed,"<?xml-stylesheet  href=\"http://feeds.feedburner.com/~d/styles/itemcontent.css\" ".
			"type=\"text/css\" media=\"screen\"?>\n");
		fwrite($feed,"<rss  xmlns:content=\"http://purl.org/rss/1.0/modules/content/\" ".
			"xmlns:wfw=\"http://wellformedweb.org/CommentAPI/\" ".
			"xmlns:dc=\"http://purl.org/dc/elements/1.1/\" ".
			"xmlns:geo=\"http://www.w3.org/2003/01/geo/wgs84_pos#\" ".
			"xmlns:feedburner=\"http://rssnamespace.org/feedburner/ext/1.0\" version=\"2.0\">\n");


		fwrite($feed,"<channel>\n");

		/* get church info */
		fwrite($feed,"<title>$church_name</title>\n");

		fwrite($feed,"<link>".$church_url."</link>\n");

		fwrite($feed,"<language>en-us</language>\n");

		fwrite($feed,"<copyright>&#x2117; &amp; &#xA9; ".date("Y").
				" $church_name</copyright>\n");

		fwrite($feed,"<description>Sermons from $church_name".
				"</description>\n");

		
		/* now get all published sermons */
		$query = "SELECT ls_sermons.title,sermondate,synopsis,fullname,ls_sermons.id ".
			"FROM ls_sermons,ls_pastors WHERE ".
			"published>0 AND ".
			"ls_pastors.id = ls_sermons.pastor ORDER BY sermondate DESC";
		$result = sql_getresult($query);

		while($row=sql_getrow($result))
			{
 			fwrite($feed,"<item>\n");
	
			fwrite($feed,"<title>".stripslashes($row[0])."</title>\n");
	
			fwrite($feed,"<dc:creator>".stripslashes($row[3])."</dc:creator>\n");
	
			fwrite($feed,"<description>\n".strip_tags(stripslashes($row[2]))."\n</description>\n");
	
			fwrite($feed,"<guid>".$sermonfile."?id=".stripslashes($row[4])."</guid>\n");

			fwrite($feed,"<pubDate>".date("D, j M Y",strtotime($row[1]))." 10:30:00 CST</pubDate>\n");
	
			/* get topics */
			$q2 = "SELECT topic FROM ls_sermon_topics WHERE sermonid='$row[4]'";
			$re2 = sql_getresult($q2);
			while($ro2 = sql_getrow($re2))
				fwrite($feed, "<category>".stripslashes($ro2[0])."</category>\n");
				
			fwrite($feed,"</item>\n\n");
			} /* end while looping through sermons */

		fwrite($feed,"</channel>\n");

		fwrite($feed,"</rss>\n");
		} /* end if opened feed file */
	} /* end of update_feed function */
?>
