<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: Add Object Type                                                */
/*                                                                      */
/* Description: This is a tool for building the database entries for a  */
/*  new type of object to be managed by Living Stones.                  */
/*                                                                      */
/*                                                                      */
/************************************************************************/

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");
require_once("./ls_include/Authfunctions.php");
require_once("./ls_include/BibleFunctions2.php");


$objectsingular = addslashes($_POST['objectsingular']);
$objectplural = addslashes($_POST['objectplural']);
$defaultlevel = $_POST['defaultlevel'];
if(strlen($defaultlevel) < 1) $defaultlevel=0;
$submit = $_POST['submit'];

function addobjectentries($objectsingular,$objectplural,$defaultlevel)
	{
	/* first strip out any spaces */
	$strobjectsingular = str_replace(" ","",$objectsingular);
	$strobjectplural = str_replace(" ","",$objectplural);

	/* next create appropriately cased instances */
	$lobjectsingular = strtolower($strobjectsingular);
	$lobjectplural = strtolower($strobjectplural);

	$uobjectsingular = strtoupper(substr($lobjectsingular,0,1)).
		substr($lobjectsingular,1);
	$uobjectplural = strtoupper(substr($lobjectplural,0,1)).
		substr($lobjectplural,1);

	$dbtable = "ls_".$lobjectplural;

	/* add entry to ls_security_objects */
	$query = "SELECT id FROM ls_security_objects WHERE dbtable='$dbtable'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$typeid = $row[0];
		echo "ls_security_object entry for $objectplural already exists ($typeid)<br />\n";
		}
	else
		{
		$query = "INSERT INTO ls_security_objects SET ".
			"object_desc='$uobjectplural', ".
			"dbtable='ls_".$lobjectplural."'";
		sql_getresult($query);
		$typeid = sql_getid();

		echo "ls_security_object entry added for $objectplural ($typeid)<br />\n";
		}
	
	/* create new security levels */
	$query = "SELECT id FROM ls_security_levels WHERE object_type='$typeid' AND ".
		"auth_name='No Access'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$noaccessid = $row[0];
		echo "No Access level already exists for $objectplural ($noaccessid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_levels SET ".
			"object_type='$typeid', ".
			"auth_name='No Access', ".
			"auth_level='0'";
		sql_getresult($query);
		$noaccessid = sql_getid();
		echo "No Access level created for $objectplural ($noaccessid)<br />\n";
		}
	$query = "SELECT id FROM ls_security_levels WHERE object_type='$typeid' AND ".
		"auth_name='View Info'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$viewinfoid = $row[0];
		echo "View Info level already exists for $objectplural ($viewinfoid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_levels SET ".
			"object_type='$typeid', ".
			"auth_name='View Info', ".
			"auth_level='20'";
		sql_getresult($query);
		$viewinfoid = sql_getid();
		echo "View Info level created for $objectplural ($viewinfoid)<br />\n";
		}
	$query = "SELECT id FROM ls_security_levels WHERE object_type='$typeid' AND ".
		"auth_name='Administer'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$administerid = $row[0];
		echo "Administer level already exists for $objectplural ($administerid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_levels SET ".
			"object_type='$typeid', ".
			"auth_name='Administer', ".
			"auth_level='50'";
		sql_getresult($query);
		$administerid = sql_getid();
		echo "Administer level created for $objectplural ($administerid)<br />\n";
		}
	$query = "SELECT id FROM ls_security_levels WHERE object_type='$typeid' AND ".
		"auth_name='Staff Access'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$staffid = $row[0];
		echo "Staff Access level already exists for $objectplural ($staffid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_levels SET ".
			"object_type='$typeid', ".
			"auth_name='Staff Access', ".
			"auth_level='60'";
		sql_getresult($query);
		$staffid = sql_getid();
		echo "Staff Access level created for $objectplural ($staffid)<br />\n";
		}
	$query = "SELECT id FROM ls_security_levels WHERE object_type='$typeid' AND ".
		"auth_name='Manage Self'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$manageselfid = $row[0];
		echo "Manage Self level already exists for $objectplural ($manageselfid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_levels SET ".
			"object_type='$typeid', ".
			"auth_name='Manage Self', ".
			"auth_level='70'";
		sql_getresult($query);
		$manageselfid = sql_getid();
		echo "Manage Self level created for $objectplural ($manageselfid)<br />\n";
		}

	/* add in functions */
	$query = "SELECT id FROM ls_security_functions WHERE object_type='$typeid' AND ".
		"lsfunction='Set Levels'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$setlevelsid = $row[0];
		echo "Set Levels function already exists for $objectplural ($setlevelsid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_functions SET ".
			"object_type='$typeid', ".
			"lsfunction='Set Levels'";
		sql_getresult($query);
		$setlevelsid = sql_getid();
		echo "Set Levels function created for $objectplural ($setlevelsid)<br />\n";
		}
	$query = "SELECT id FROM ls_security_functions WHERE object_type='$typeid' AND ".
		"lsfunction='Add ".$uobjectplural."'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$addobjectid = $row[0];
		echo "Add ".$uobjectplural." function already exists for $objectplural ($addobjectid)<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_functions SET ".
			"object_type='$typeid', ".
			"lsfunction='Add ".$uobjectplural."'";
		sql_getresult($query);
		$addobjectid = sql_getid();
		echo "Add ".uobjectplural." function created for $objectplural ($addobjectid)<br />\n";
		}
	
	/* add security entries for functions */
	$query = "SELECT id FROM ls_security_function_levels WHERE lsfunction='$setlevelsid'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		echo "Set Levels security level already exists for $objectplural ($row[0])<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_function_levels SET ".
			"level='$administerid', ".
			"lsfunction='$setlevelsid'";
		sql_getresult($query);
		echo "Set Levels security level created for $objectplural <br />\n";
		}
	$query = "SELECT id FROM ls_security_function_levels WHERE lsfunction='$addobjectid' ".
			"AND level='$administerid'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		echo "Add Object security level for Administers already exists for $objectplural ($row[0])<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_function_levels SET ".
			"level='$administerid', ".
			"lsfunction='$addobjectid'";
		sql_getresult($query);
		echo "Add Object security level for Administers created for $objectplural <br />\n";
		}
	$query = "SELECT id FROM ls_security_function_levels WHERE lsfunction='$addobjectid' ".
			"AND level='$staffid'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		echo "Add Object security level for Staff Access already exists for $objectplural ($row[0])<br />\n";
		}
	else
		{ 
		$query = "INSERT INTO ls_security_function_levels SET ".
			"level='$staffid', ".
			"lsfunction='$addobjectid'";
		sql_getresult($query);
		echo "Add Object security level for Staff Access created for $objectplural <br />\n";
		}

	/* now add entries for each field */
	/* get the field names */
	$fieldnames = sql_getfields($dbtable);

	/* Start with No Access */
	/* Note: Skipping field 0 since we don't want to bother folks with the id */
	for($i = 1; $i<count($fieldnames);$i++)
		{
		$query = "SELECT readauth,writeauth FROM ls_security_fields ".
			"WHERE level='$noaccessid' AND fieldname='$fieldnames[$i]'";
		$result = sql_getresult($query);
		if($row = sql_getrow($result))
			echo "Security already set for No Access on $fieldnames[$i] for $objectplural <br />\n";
		else
			{
			$query = "INSERT INTO ls_security_fields SET ".
				"level='$noaccessid',fieldname='$fieldnames[$i]',".
				"readauth='0',writeauth='0'";
			sql_getresult($query);
			}
		} /* end while looping through fields */

	/* View Info */
	/* Note: Skipping field 0 since we don't want to bother folks with the id */
	for($i = 1; $i<count($fieldnames);$i++)
		{
		$query = "SELECT readauth,writeauth FROM ls_security_fields ".
			"WHERE level='$viewinfoid' AND fieldname='$fieldnames[$i]'";
		$result = sql_getresult($query);
		if($row = sql_getrow($result))
			echo "Security already set for View Info on $fieldnames[$i] for $objectplural <br />\n";
		else
			{
			$query = "INSERT INTO ls_security_fields SET ".
				"level='$viewinfoid',fieldname='$fieldnames[$i]',".
				"readauth='1',writeauth='0'";
			sql_getresult($query);
			}
		} /* end while looping through fields */

	/* Administer */
	/* Note: Skipping field 0 since we don't want to bother folks with the id */
	for($i = 1; $i<count($fieldnames);$i++)
		{
		$query = "SELECT readauth,writeauth FROM ls_security_fields ".
			"WHERE level='$administerid' AND fieldname='$fieldnames[$i]'";
		$result = sql_getresult($query);
		if($row = sql_getrow($result))
			echo "Security already set for Administer on $fieldnames[$i] for $objectplural <br />\n";
		else
			{
			$query = "INSERT INTO ls_security_fields SET ".
				"level='$administerid',fieldname='$fieldnames[$i]',".
				"readauth='1',writeauth='1'";
			sql_getresult($query);
			}
		} /* end while looping through fields */

	/* Staff Access */
	/* Note: Skipping field 0 since we don't want to bother folks with the id */
	for($i = 1; $i<count($fieldnames);$i++)
		{
		$query = "SELECT readauth,writeauth FROM ls_security_fields ".
			"WHERE level='$staffid' AND fieldname='$fieldnames[$i]'";
		$result = sql_getresult($query);
		if($row = sql_getrow($result))
			echo "Security already set for Staff Access on $fieldnames[$i] for $objectplural <br />\n";
		else
			{
			$query = "INSERT INTO ls_security_fields SET ".
				"level='$staffid',fieldname='$fieldnames[$i]',".
				"readauth='1',writeauth='1'";
			sql_getresult($query);
			}
		} /* end while looping through fields */

	/* Manage Self */
	/* Note: Skipping field 0 since we don't want to bother folks with the id */
	for($i = 1; $i<count($fieldnames);$i++)
		{
		$query = "SELECT readauth,writeauth FROM ls_security_fields ".
			"WHERE level='$manageselfid' AND fieldname='$fieldnames[$i]'";
		$result = sql_getresult($query);
		if($row = sql_getrow($result))
			echo "Security already set for Manage Self on $fieldnames[$i] for $objectplural <br />\n";
		else
			{
			$query = "INSERT INTO ls_security_fields SET ".
				"level='$manageselfid',fieldname='$fieldnames[$i]',".
				"readauth='1',writeauth='1'";
			sql_getresult($query);
			}
		} /* end while looping through fields */

	/* add security entries for the default user and for the admin */
	if($defaultlevel == 0) $defaultlevelid = $noaccessid;
	if($defaultlevel == 20) $defaultlevelid = $viewinfoid;
	if($defaultlevel == 50) $defaultlevelid = $administerid;
	if($defaultlevel == 60) $defaultlevelid = $staffid;
	if($defaultlevel == 70) $defaultlevelid = $manageselfid;

	/* default user access to all entries */
	$query = "SELECT id FROM ls_security_auth WHERE object_type='$typeid' AND ".
			"object_id='0' AND user_id='0'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		echo "Already a security entry for Default User for $objectplural.<br />\n";
	else
		{
		$query = "INSERT INTO ls_security_auth SET object_type='$typeid',".
			"object_id='0',user_id='0',levelid='$defaultlevelid'";
		sql_getresult($query);
		}

	/* admin user access to all entries */
	$query = "SELECT id FROM ls_security_auth WHERE object_type='$typeid' AND ".
			"object_id='0' AND user_id='1'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		echo "Already a security entry for Admin access to all entries for $objectplural.<br />\n";
	else
		{
		$query = "INSERT INTO ls_security_auth SET object_type='$typeid',".
			"object_id='0',user_id='1',levelid='$administerid'";
		sql_getresult($query);
		}

	/* admin user access to Set Levels */
	$query = "SELECT id FROM ls_security_auth WHERE object_type='0' AND ".
			"object_id='$setlevelsid' AND user_id='1'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		echo "Already a security entry for Admin to Set Levels for $objectplural.<br />\n";
	else
		{
		$query = "INSERT INTO ls_security_auth SET object_type='0',".
			"object_id='$setlevelsid',user_id='1',levelid='$administerid'";
		sql_getresult($query);
		}

	/* admin user access to Add Objects */
	$query = "SELECT id FROM ls_security_auth WHERE object_type='0' AND ".
			"object_id='$addobjectid' AND user_id='1'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		echo "Already a security entry for Admin to Add Objects for $objectplural.<br />\n";
	else
		{
		$query = "INSERT INTO ls_security_auth SET object_type='0',".
			"object_id='$addobjectid',user_id='1',levelid='$administerid'";
		sql_getresult($query);
		}

	} /* end function addobjectentries */

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
$thispage = $_SERVER['SCRIPT_NAME'];
$parts = explode("/",$thispage);
$thispage = $parts[(count($parts)-1)];

/* find out who this user is, if they have logged in */
$thisuser = $_SESSION["lsuid"];

/* if not already logged in, then set their userid to 0 */
if(strlen($thisuser) < 1) 
	{
	$thisuser = 0;
	}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml11/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Living Stones Install Sermons Package</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" href="./ls_include/lsadmin.css" />

<?php
echo "<!-- script: $thisscript page: $thispage -->\n";
/* if not already logged in, then we need to log-in */
/***  NOTE: If you've placed the login page somewhere other than ls_login.php, change that reference below ***/
if(strlen($thisuser) != 1) 
	{
	echo "<script language='javascript'>\n";
	echo "window.location = 'ls_login.php?return_path=$thisscript&message=".
		urlencode("Only the Administrator can run this program.  Please login as the administrator.")."';\n";
	echo "</script>\n";
	}
?>

<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>
</head>
<body onLoad='document.forms[0].elements[0].focus()'>


<?php
/************************************************************************/
/* The page starts here                                                 */
/************************************************************************/
?>
<div id="Box1">

<div id="Box11">
<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LivingStones.gif"></a>
</div> <!-- Box11 -->

<div id="Box13">

<div id="Box131">
<span>Install Sermons Package</span>
</div> <!-- Box131 -->

</div> <!-- Box13 -->

</div> <!-- Box1 -->

<div id="Box3">

<div id="Box31">
<?php 
/* This will figure out what options to place in the left column menu */
create_admin_menu($thisuser,$thispage,$LS_ADMIN_THRESHOLD);
?>
</div> <!-- Box31 -->

<div id="Box33">
<div id="Box331">
<p>This program is used to set up the database to support the Manage Sermons and
Manage Pastors tools that are part of the Living Stones Sermons package.</p>
<p>When you click the "Begin" button below, the process will begin, messages will indicate the progress.
If there are any problems, you can restart the process and it will identify which steps have already been
completed and just complete the remaining steps.</p>
<?php
if($thisuser == 1)
	{
	echo "<form method=POST action=\"$thisscript\">\n";

	echo "<input type=submit name=submit value=\"             Begin           \"></td></tr>\n";
	echo "</form>\n";

	if(strlen($submit) > 0)
		{
		/* user hit Begin - install the components */
		
		/* Start by creating the database tables */

		if(sql_check4table("ls_pastors"))
			{
			echo "The table ls_pastors already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_pastors (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"fullname VARCHAR(255) NOT NULL, title VARCHAR(255) NOT NULL, ".
				"bio VARCHAR(255) NOT NULL, peopleid INTEGER UNSIGNED)";
			sql_getresult($query);
			}
		if(sql_check4table("ls_sermons"))
			{
			echo "The table ls_sermons already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_sermons (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"title VARCHAR(255) NOT NULL, sermondate DATE, ".
				"synopsis TEXT, pastor INTEGER UNSIGNED, ".
				"published SMALLINT, series INTEGER UNSIGNED)";
			sql_getresult($query);
			}
		if(sql_check4table("ls_sermon_files"))
			{
			echo "The table ls_sermon_files already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_sermon_files (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"sermonid INTEGER UNSIGNED, uploadtype VARCHAR(255) NOT NULL, ".
				"uploadurl VARCHAR(255) NOT NULL, filesize INTEGER)";
			sql_getresult($query);
			}
		if(sql_check4table("ls_sermon_series"))
			{
			echo "The table ls_sermon_series already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_sermon_series (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"series VARCHAR(255) NOT NULL)";
			sql_getresult($query);
			}
		if(sql_check4table("ls_sermon_texts"))
			{
			echo "The table ls_sermon_texts already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_sermon_texts (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"sermonid INTEGER UNSIGNED, scripturetext VARCHAR(255) NOT NULL, ".
				"startref VARCHAR(255) NOT NULL, endref VARCHAR(255) NOT NULL)";
			sql_getresult($query);
			}
		if(sql_check4table("ls_sermon_topics"))
			{
			echo "The table ls_sermon_topics already exists.<br />\n";
			}
		else
			{
			$query = "CREATE TABLE ls_sermon_topics (id INTEGER UNSIGNED AUTO_INCREMENT PRIMARY KEY, ".
				"sermonid INTEGER UNSIGNED, topic VARCHAR(255) NOT NULL)";
			sql_getresult($query);
			}

		/* Now add security entries for each object type */

		addobjectentries("Pastor","Pastors",20);
		addobjectentries("Sermon","Sermons",20);

		echo "<p>Installation complete. ".
			"<a href=\"ls_manage_pastors.php\">Click here</a> to get started.</p>";

		} /* end if user hit Begin */
	} /* end if admin */
else
	echo "Only the admin user can perform this function.<br />\n".
		"<a href=ls_login.php>Click here to login.</a>";
?>
</div> <!-- Box331 -->
</div> <!-- Box33 -->

</div> <!-- Box3 -->

<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>
