<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: Search Sermons                                                 */
/*                                                                      */
/* Description: This is designed to be dropped into a website to        */
/*   provide a way for users to search through the sermons stored on    */
/*   the site.                                                          */
/*                                                                      */
/*   You can modify this to match your site's design.                   */
/*                                                                      */
/************************************************************************/

/************************************************************************/
/* If you've installed the Living Stones Bible software on your site    */
/* replace the address below with the right one for your site.          */
/************************************************************************/
$bibleurl = "http://www.seek-first.com/Bible.php?p=";

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");
require_once("./ls_include/Authfunctions.php");
require_once("./ls_include/BibleFunctions2.php");

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
$thispage = $_SERVER['SCRIPT_NAME'];
$parts = explode("/",$thispage);
$thispage = $parts[(count($parts)-1)];

$query = "SELECT id,dbtable FROM ls_security_objects WHERE object_desc = 'Sermons'";
$result = sql_getresult($query);
$row = sql_getrow($result);
$objecttype = $row[0];
$dbtable = $row[1];

/* find out who this user is, if they have logged in */
$thisuser = $_SESSION["lsuid"];

/* if not already logged in, then set their userid to 0 */
if(strlen($thisuser) < 1) 
	{
	$thisuser = 0;
	}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="Keywords" content="" />
<meta name="Description" content="" />
<meta name="rating" content="General" />


<title>Search Sermons</title>
<style type="text/css">
<!--
#sermonnav span
	{
	text-decoration: none;
	display: inline;
	padding: 5px;
	border-left: 1px solid black;
	border-top: 1px solid black;
	border-right: 1px solid black;
	color: black;
	}

#sermonnav a
	{
	text-decoration: none;
	padding-bottom: 5px;
	padding-top: 5px;
	background-color: #F4F4F4;
	border-bottom: 1px solid black;
	}

#sermonnav a:hover
	{
	text-decoration: none;
	font-weight: bold;
	}
-->
</style>
<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>
</head>
<body>
<div id="sermonnav">
<a href="ls_sermons_by_date.php"><span>By Date</span></a>
<a href="ls_sermons_by_series.php"><span>By Series</span></a>
<a href="ls_sermons_by_topic.php"><span>By Topic</span></a>
<a href="ls_sermons_by_scripture.php"><span>By Scripture Text</span></a>
<a href="ls_sermons_by_pastor.php"><span>By Pastor</span></a>
<span>Search</span>
</div> <!-- sermonnav -->
<?php
/************************************************************************/
/* The page starts here                                                 */
/************************************************************************/
$q = $_GET['q'];
$sort1 = $_GET['sort1'];
if(strlen($sort1) < 1) $sort1 = "Relevance";

function check_duplicates($array,$value)
	{
	/* returns TRUE if there is NOT a duplicate */

	for($i=0;$i<count($array);$i++)
		if($value == $array[$i]) return FALSE;
	
	return TRUE;
	} /* end function check_duplicates */

?>
<p style="font-weight: bold;font-size: 18pt;">Search Sermons</p>
<form method=GET action="<?php echo $thisscript;?>">
<input type=text name=q size=30 value="<?php echo $q;?>"><input type=submit value="Search"><br />
Order By: <select name=sort1 size=1 onChange="this.form.submit()">
<option value=Relevance<?php if($sort1 == "Relevance") echo " selected";?>>Relevance</option>
<option value=Date<?php if($sort1 == "Date") echo " selected";?>>Date</option>
</select><?php
$showsynopsis = 1;
$showtexts = 1;
if(strlen($q) > 0)
	{
	$sq = "%".addslashes($q)."%";
	$j = 0;
	/* first get the results by relevance - title first, then text, then topics, then series, then synopsis */

	/* first search for the exact phrase */

	/* title */
	$query = "SELECT id FROM $dbtable WHERE title LIKE '$sq' AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		$matches[$j++] = $row[0]; /* don't have to worry about duplicates yet */

	/* texts */
	$query = "SELECT sermonid FROM ls_sermon_texts WHERE scripturetext LIKE '$sq' ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* topics */
	$query = "SELECT sermonid FROM ls_sermon_topics WHERE topic LIKE '$sq' ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* series */
	$query = "SELECT id FROM ls_sermon_series WHERE series LIKE '$sq'";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		{
		$q2 = "SELECT id FROM $dbtable WHERE series='$row[0]' AND published>0 ORDER BY sermondate DESC";
		$re2 = sql_getresult($q2);
		while($ro2 = sql_getrow($re2))
			if(check_duplicates($matches,$ro2[0]))
				$matches[$j++] = $ro2[0];
		}

	/* synopsis */
	$query = "SELECT id FROM $dbtable WHERE synopsis LIKE '$sq' AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(check_duplicates($matches,$row[0]))
			$matches[$j++] = $row[0];

	/* now search for matching all the words */
	$words = explode(" ",$q);
	for($i=0; $i<count($words);$i++)
		{
		$words[$i] = "%".addslashes($words[$i])."%";
		}

	/* title */
	$query = "SELECT id FROM $dbtable WHERE (title LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "AND title LIKE '$words[$i]' ";
	$query .= ") AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(check_duplicates($matches,$row[0]))
			$matches[$j++] = $row[0]; 

	/* texts */
	$query = "SELECT sermonid FROM ls_sermon_texts WHERE (scripturetext LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "AND scripturetext LIKE '$words[$i]' ";
	$query .= ") ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* topics */
	$query = "SELECT sermonid FROM ls_sermon_topics WHERE (topic LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "AND topic LIKE '$words[$i]' ";
	$query .= ") ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* series */
	$query = "SELECT id FROM ls_sermon_series WHERE (series LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "AND series LIKE '$words[$i]' ";
	$query .= ")";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		{
		$q2 = "SELECT id FROM $dbtable WHERE series='$row[0]' AND published>0 ORDER BY sermondate DESC";
		$re2 = sql_getresult($q2);
		while($ro2 = sql_getrow($re2))
			if(check_duplicates($matches,$ro2[0]))
				$matches[$j++] = $ro2[0];
		}

	/* synopsis */
	$query = "SELECT id FROM $dbtable WHERE (synopsis LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "AND synopsis LIKE '$words[$i]' ";
	$query .= ") AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(check_duplicates($matches,$row[0]))
			$matches[$j++] = $row[0];

	/* now search for matching any of the words */

	/* title */
	$query = "SELECT id FROM $dbtable WHERE (title LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "OR title LIKE '$words[$i]' ";
	$query .= ") AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(check_duplicates($matches,$row[0]))
			$matches[$j++] = $row[0]; 

	/* texts */
	$query = "SELECT sermonid FROM ls_sermon_texts WHERE (scripturetext LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "OR scripturetext LIKE '$words[$i]' ";
	$query .= ") ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* topics */
	$query = "SELECT sermonid FROM ls_sermon_topics WHERE (topic LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "OR topic LIKE '$words[$i]' ";
	$query .= ") ORDER BY sermonid DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(sql_getone("SELECT published FROM $dbtable WHERE id='$row[0]'") > 0)
			if(check_duplicates($matches,$row[0]))
				$matches[$j++] = $row[0];

	/* series */
	$query = "SELECT id FROM ls_sermon_series WHERE (series LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "OR series LIKE '$words[$i]' ";
	$query .= ")";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		{
		$q2 = "SELECT id FROM $dbtable WHERE series='$row[0]' AND published>0 ORDER BY sermondate DESC";
		$re2 = sql_getresult($q2);
		while($ro2 = sql_getrow($re2))
			if(check_duplicates($matches,$ro2[0]))
				$matches[$j++] = $ro2[0];
		}

	/* synopsis */
	$query = "SELECT id FROM $dbtable WHERE (synopsis LIKE '$words[0]' ";
	for($i=1;$i<count($words);$i++)
		$query .= "OR synopsis LIKE '$words[$i]' ";
	$query .= ") AND published>0 ORDER BY sermondate DESC";
	$result = sql_getresult($query);
	while($row = sql_getrow($result))
		if(check_duplicates($matches,$row[0]))
			$matches[$j++] = $row[0];


	/* Now if the order is by date - then need to reorder */
	if($sort1 == "Date")
		{
		/* create a new array with date as key */
		for($i=0;$i < count($matches);$i++)
			{
			$thisdate = sql_getone("SELECT sermondate FROM $dbtable WHERE id='$matches[$i]'");
			$dmatches[$thisdate] = $matches[$i];
			}

		/* now sort in reverse by the date key */
		krsort($dmatches);

		/* and refill matches */
		$i = 0;
		foreach($dmatches as $key => $val)
			$matches[$i++] = $val;
		} /* end if sort by date */

	/* now print out the found sermons */
	for($i=0;$i < count($matches);$i++)
		{
		echo "<ul>\n"; /* could use CSS to style this list */
		$query = "SELECT id,title,sermondate,pastor,synopsis ".
				"FROM $dbtable ".
				"WHERE id='$matches[$i]'";
		$result = sql_getresult($query);
		while($row=sql_getrow($result))
			{
			if(check_auth($thisuser,$objecttype,$row[0],$LS_USER_THRESHOLD))
				{
				$sermonid = $row[0];
				$title = stripslashes($row[1]);
				$pastor = stripslashes(sql_getone("SELECT fullname FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				$bio = stripslashes(sql_getone("SELECT bio FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				if(strlen($bio) > 0) $pastor = "<a href=$bio>$pastor</a>";
				$date = date("F j, Y",strtotime($row[2]));
				$synopsis = stripslashes($row[4]);
	
				echo "<li><b>$title</b> ($pastor, $date) ";
				/* now find all attachments */
				$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
					"WHERE sermonid='$sermonid'";
				$re2 = sql_getresult($q2);
				while($ro2 = sql_getrow($re2))
					{
					if(stripslashes($ro2[1]) == "Text/PDF")
						echo "<a href=".stripslashes($ro2[2]).">".
							"<img border=0 height=25 width=25 ".
							"src='ls_include/book05.gif'>".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Picture")
						echo "<a href=".stripslashes($ro2[2]).">".
							"<img border=0 height=25 width=25 ".
							"src='ls_include/camera1.gif'>".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Presentation")
						echo "<a href=".stripslashes($ro2[2]).">".
							"<img border=0 height=25 width=25 ".
							"src='ls_include/pc01.gif'>".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Audio")
						echo "<a href=".stripslashes($ro2[2]).">".
							"<img border=0 height=25 width=25 ".
							"src='ls_include/sound01.gif'>".
							"</a>\n";
					else
						echo "<a href=".stripslashes($ro2[2]).">".
							"<img border=0 height=25 width=25 ".
							"src='ls_include/film02.gif'>".
							"</a>\n";
					
					} /* end while looping through associated files */
				if($showsynopsis == 1)
					echo "<br />\n$synopsis\n";
	
				if($showtexts == 1)
					{
					echo "<br />(Text: ";
					$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
						"WHERE sermonid='$row[0]'";
					$re2 = sql_getresult($q2);
					if($ro2 = sql_getrow($re2)) 
						echo "<a href='$bibleurl".urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					while($ro2 = sql_getrow($re2))
						{
						echo ", <a href='$bibleurl".urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
						}
					echo ")\n";
					} /* end if showtexts */

				if(($showtexts == 1) OR ($showsynopsis == 1)) echo "<br />\n";

				echo "</li>\n";
				} /* end if authorized */
			} /* end while looping through sermons */
		echo "</ul></p>\n";
		} /* end while looping through matches */

	} /* end if $q - there's something to search for */
?>
</form>
<br />
<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>




