<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: List Sermons                                                   */
/*                                                                      */
/* Description: This is designed to be dropped into a website to        */
/*   display the information for a specific sermon.                     */
/*                                                                      */
/*   The formating in this example is quite simple.  You will likely    */
/*   want to add formating to match your site.                          */
/*                                                                      */
/************************************************************************/

/************************************************************************/
/* If you've installed the Living Stones Bible software on your site    */
/* replace the address below with the right one for your site.          */
/************************************************************************/
$bibleurl = "http://www.seek-first.com/Bible.php?p=";

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");
require_once("./ls_include/Authfunctions.php");
require_once("./ls_include/BibleFunctions2.php");

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
$thispage = $_SERVER['SCRIPT_NAME'];
$parts = explode("/",$thispage);
$thispage = $parts[(count($parts)-1)];
$id=addslashes($_GET['id']);

$query = "SELECT id,dbtable FROM ls_security_objects WHERE object_desc = 'Sermons'";
$result = sql_getresult($query);
$row = sql_getrow($result);
$objecttype = $row[0];
$dbtable = $row[1];

/* find out who this user is, if they have logged in */
$thisuser = $_SESSION["lsuid"];

/* if not already logged in, then set their userid to 0 */
if(strlen($thisuser) < 1) 
	{
	$thisuser = 0;
	}

$query = "SELECT title,sermondate,pastor,synopsis FROM $dbtable ".
		"WHERE id='$id'";
$result = sql_getresult($query);
$row = sql_getrow($result);
$title = stripslashes($row[0]);
$date = date("F j, Y",strtotime($row[1]));
$pastor = $row[2];
$synopsis = stripslashes($row[3]);
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="Keywords" content="" />
<meta name="Description" content="" />
<meta name="rating" content="General" />


<title><?php echo $title;?></title>

<style type="text/css">
<!--
#sermonnav span
	{
	text-decoration: none;
	display: inline;
	padding: 5px;
	border-left: 1px solid black;
	border-top: 1px solid black;
	border-right: 1px solid black;
	color: black;
	}

#sermonnav a
	{
	text-decoration: none;
	padding-bottom: 5px;
	padding-top: 5px;
	background-color: #F4F4F4;
	border-bottom: 1px solid black;
	}

#sermonnav a:hover
	{
	text-decoration: none;
	font-weight: bold;
	}
-->
</style>
<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>
</head>
<body>
<?php /***********************************************************************/
/* If these files have changed names or moved, make appropriate changes here */
/*****************************************************************************/?>
<div id="sermonnav">
<a href="ls_sermons_by_date.php"><span>By Date</span></a>
<a href="ls_sermons_by_series.php"><span>By Series</span></a>
<a href="ls_sermons_by_topic.php"><span>By Topic</span></a>
<a href="ls_sermons_by_scripture.php"><span>By Scripture Text</span></a>
<a href="ls_sermons_by_pastor.php"><span>By Pastor</span></a>
<a href="ls_search_sermons.php"><span>Search</span></a>
</div> <!-- sermonnav -->
<p style="font-weight: bold;font-size: 18pt;"><?php echo $title;?></p>
<?php
if(check_auth($thisuser,$objecttype,$id,$LS_USER_THRESHOLD))
	{
	echo "<p>$date ";
	/* now find all attachments */
	$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
		"WHERE sermonid='$id'";
	$re2 = sql_getresult($q2);
	while($ro2 = sql_getrow($re2))
		{
		if(stripslashes($ro2[1]) == "Text/PDF")
			echo "<a href=".stripslashes($ro2[2]).">".
				"[read]".
				"</a>\n";
		elseif(stripslashes($ro2[1]) == "Picture")
			echo "<a href=".stripslashes($ro2[2]).">".
				"[view]".
				"</a>\n";
		elseif(stripslashes($ro2[1]) == "Presentation")
			echo "<a href=".stripslashes($ro2[2]).">".
				"[see]".
				"</a>\n";
		elseif(stripslashes($ro2[1]) == "Audio")
			echo "<a href=".stripslashes($ro2[2]).">".
				"[listen]".
				"</a>\n";
		else
			echo "<a href=".stripslashes($ro2[2]).">".
				"[watch]".
				"</a>\n";
		
		} /* end while looping through associated files */
	echo "<br />\n$synopsis\n";

	echo "<br />(Text: ";
	$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
		"WHERE sermonid='$id'";
	$re2 = sql_getresult($q2);
	if($ro2 = sql_getrow($re2)) 
		echo "<a href='$bibleurl".
			urlencode(stripslashes($ro2[0])).
			"'>".stripslashes($ro2[0])."</a>";
	while($ro2 = sql_getrow($re2))
		echo ", <a href='$bibleurl".
			urlencode(stripslashes($ro2[0])).
			"'>".stripslashes($ro2[0])."</a>";
	echo ")\n";
	echo "<br /><br />\n";


	echo "</p>\n";
	} /* end if authorized */
?>
<p style="font-weight: bold;font-size: 18pt;">Search Sermons</p>
<?php/********************************************************************/
/*     If the search form is somewhere else, change this address         */
/*************************************************************************/?>
<form method=GET action="ls_search_sermons.php">
<input type=text name=q size=30><input type=submit value="Search">
</form>
<br />
<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>



