<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: List Sermons by Topic                                          */
/*                                                                      */
/* Description: This is designed to be dropped into a website to        */
/*   provide a way for users to browse through the sermons stored on    */
/*   the site.  This specific building block allows them to browse by   */
/*   sermon topic.                                                      */
/*                                                                      */
/*   This page can also just list all sermons on a given topic by       */
/*   passing the sermon topic as 'topic'.                               */
/*   This way, for example, you can have a link from the church home    */
/*   page to a specific relevant topic.                                 */
/*                                                                      */
/*   You can modify this to match your site's design.                   */
/*                                                                      */
/************************************************************************/

/************************************************************************/
/* If you've installed the Living Stones Bible software on your site    */
/* replace the address below with the right one for your site.          */
/************************************************************************/
$bibleurl = "http://www.seek-first.com/Bible.php?p=";

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");
require_once("./ls_include/Authfunctions.php");
require_once("./ls_include/BibleFunctions2.php");

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
$thispage = $_SERVER['SCRIPT_NAME'];
$parts = explode("/",$thispage);
$thispage = $parts[(count($parts)-1)];

$query = "SELECT id,dbtable FROM ls_security_objects WHERE object_desc = 'Sermons'";
$result = sql_getresult($query);
$row = sql_getrow($result);
$objecttype = $row[0];
$dbtable = $row[1];

/* find out who this user is, if they have logged in */
$thisuser = $_SESSION["lsuid"];

/* if not already logged in, then set their userid to 0 */
if(strlen($thisuser) < 1) 
	{
	$thisuser = 0;
	}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="Keywords" content="" />
<meta name="Description" content="" />
<meta name="rating" content="General" />


<title>Sermons by Topic</title>
<style type="text/css">
<!--
#sermonnav span
	{
	text-decoration: none;
	display: inline;
	padding: 5px;
	border-left: 1px solid black;
	border-top: 1px solid black;
	border-right: 1px solid black;
	color: black;
	}

#sermonnav a
	{
	text-decoration: none;
	padding-bottom: 5px;
	padding-top: 5px;
	background-color: #F4F4F4;
	border-bottom: 1px solid black;
	}

#sermonnav a:hover
	{
	text-decoration: none;
	font-weight: bold;
	}
-->
</style>
<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>
</head>
<body>
<div id="sermonnav">
<a href="ls_sermons_by_date.php"><span>By Date</span></a>
<a href="ls_sermons_by_series.php"><span>By Series</span></a>
<span>By Topic</span>
<a href="ls_sermons_by_scripture.php"><span>By Scripture Text</span></a>
<a href="ls_sermons_by_pastor.php"><span>By Pastor</span></a>
<a href="ls_search_sermons.php"><span>Search</span></a>
</div> <!-- sermonnav -->
<?php
/************************************************************************/
/* The page starts here                                                 */
/************************************************************************/
$orderby = $_GET['orderby'];
if(strlen($orderby) < 1) $orderby = "Date";
$sort1 = $_GET['sort1'];
if(strlen($sort1) < 1) $sort1 = "Alphabetical";
$sort2 = $_GET['sort2'];
if(strlen($sort1) < 1) $sort1 = "Newest";
$showsynopsis = $_GET['showsynopsis'];
if(strlen($showsynopsis) < 1) $showsynopsis = 1;
$showtexts = $_GET['showtexts'];
if(strlen($showtexts) < 1) $showtexts = 1;
$topic = $_GET['topic'];
if(strlen($topic) > 0) $sort1 = "Select";
?>
<p style="font-weight: bold;font-size: 18pt;">Sermons by Topic</p>
<form method=GET action="<?php echo $thisscript;?>">
<input type=hidden name=orderby value=Topic>
<input type=hidden name=sort1 value="Alphabetical">
<input type=hidden name=showsynopsis value=1>
<input type=hidden name=showtexts value=1>
<?php
/* NOTE: You may very well want to force the order of the listing of the topics here */

if($sort1 == "Select")
	{
	echo "<p style=\"font-weight: bold;\">".$topic."\n";
	echo "<ul>\n"; /* could use CSS to style this list */
	$query = "SELECT $dbtable.id,title,sermondate,pastor,synopsis ".
			"FROM $dbtable,ls_sermon_topics ".
			"WHERE topic='".addslashes($topic)."' AND $dbtable.id=sermonid AND published>0 ";
	if($sort2 == "Oldest") $query .= "ORDER BY sermondate ASC";
	else $query .= "ORDER BY sermondate DESC";

	$result = sql_getresult($query);
	while($row=sql_getrow($result))
		{
		if(check_auth($thisuser,$objecttype,$row[0],$LS_USER_THRESHOLD))
			{
			$sermonid = $row[0];
			$title = stripslashes($row[1]);
			$pastor = stripslashes(sql_getone("SELECT fullname FROM ls_pastors ".
						"WHERE id='$row[3]'"));
			$date = date("F j, Y",strtotime($row[2]));
			$bio = stripslashes(sql_getone("SELECT bio FROM ls_pastors ".
						"WHERE id='$row[3]'"));
			if(strlen($bio) > 0) $pastor = "<a href=$bio>$pastor</a>";
			$synopsis = stripslashes($row[4]);

			echo "<li><b>$title</b> ($pastor, $date) ";
			/* now find all attachments */
			$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
				"WHERE sermonid='$sermonid'";
			$re2 = sql_getresult($q2);
			while($ro2 = sql_getrow($re2))
				{
				if(stripslashes($ro2[1]) == "Text/PDF")
					echo "<a href=".stripslashes($ro2[2]).">".
						"[read]".
						"</a>\n";
				elseif(stripslashes($ro2[1]) == "Picture")
					echo "<a href=".stripslashes($ro2[2]).">".
						"[view]".
						"</a>\n";
				elseif(stripslashes($ro2[1]) == "Presentation")
					echo "<a href=".stripslashes($ro2[2]).">".
						"[see]".
						"</a>\n";
				elseif(stripslashes($ro2[1]) == "Audio")
					echo "<a href=".stripslashes($ro2[2]).">".
						"[listen]".
						"</a>\n";
				else
					echo "<a href=".stripslashes($ro2[2]).">".
						"[watch]".
						"</a>\n";
				
				} /* end while looping through associated files */
			if($showsynopsis == 1)
				echo "<br />\n$synopsis\n";


			if($showtexts == 1)
				{
				echo "<br />(Text: ";
				$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
					"WHERE sermonid='$sermonid'";
				$re2 = sql_getresult($q2);
				if($ro2 = sql_getrow($re2)) 
					echo "<a href='$bibleurl".
						urlencode(stripslashes($ro2[0])).
						"'>".stripslashes($ro2[0])."</a>";
				while($ro2 = sql_getrow($re2))
					echo ", <a href='$bibleurl".
						urlencode(stripslashes($ro2[0])).
						"'>".stripslashes($ro2[0])."</a>";
				echo ")\n";
				} /* end if showtexts */

			if(($showtexts == 1) OR ($showsynopsis == 1)) echo "<br />\n";

			echo "</li>\n";
			} /* end if authorized */
		} /* end while looping through sermons */
	echo "</ul></p>\n";
	} /* end if topic selected */

if($sort1 == "Newest")
	{
	/* First get all the topics and sort them */
	$last = "";
	$q1 = "SELECT ls_sermon_topics.id,topic FROM ls_sermon_topics,ls_sermons ".
		"WHERE ls_sermons.id = ls_sermon_topics.sermonid AND published>'0' ORDER BY topic ASC";
	$re1 = sql_getresult($q1);
	while($ro1 = sql_getrow($re1))
		{
		/* skip duplicates */
		if($ro1[1] == $last) continue;
		$last = $ro1[1];

		/* $i will be where we insert this topic */
		/* $j will be the topic we're currently comparing him to */
		$i = count($topics);
		for($j=count($topics)-1;$j>=0;$j--)
			{
			if(sql_getone("SELECT sermondate FROM $dbtable,ls_sermon_topics ".
					"WHERE topic='$ro1[1]' AND ".
					"$dbtable.id=ls_sermon_topics.sermonid AND published>0 ".
					"ORDER BY sermondate DESC") >
				sql_getone("SELECT sermondate FROM $dbtable,ls_sermon_topics ".
					"WHERE topic='$topics[$j]' AND ".
					"$dbtable.id=ls_sermon_topics.sermonid AND published>0 ".
					"ORDER BY sermondate DESC"))
				{
				$topics[$i] = $topics[$j];
				$i = $j;
				}
			} /* end while looping through topics to sort */
		$topics[$i] = $ro1[1];
		} /* end while looping through topics */
	for($i=0;$i < count($topics);$i++)
		{
		echo "<p style=\"font-weight: bold;\">".stripslashes($topics[$i])."\n";
		echo "<ul>\n"; /* could use CSS to style this list */
		$query = "SELECT $dbtable.id,title,sermondate,pastor,synopsis ".
				"FROM $dbtable,ls_sermon_topics ".
				"WHERE topic='$topics[$i]' AND $dbtable.id=sermonid AND published>0 ".
				"ORDER BY sermondate DESC";
		$result = sql_getresult($query);
		while($row=sql_getrow($result))
			{
			if(check_auth($thisuser,$objecttype,$row[0],$LS_USER_THRESHOLD))
				{
				$sermonid = $row[0];
				$title = stripslashes($row[1]);
				$pastor = stripslashes(sql_getone("SELECT fullname FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				$date = date("F j, Y",strtotime($row[2]));
				$bio = stripslashes(sql_getone("SELECT bio FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				if(strlen($bio) > 0) $pastor = "<a href=$bio>$pastor</a>";
				$synopsis = stripslashes($row[4]);
	
				echo "<li><b>$title</b> ($pastor, $date) ";
				/* now find all attachments */
				$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
					"WHERE sermonid='$sermonid'";
				$re2 = sql_getresult($q2);
				while($ro2 = sql_getrow($re2))
					{
					if(stripslashes($ro2[1]) == "Text/PDF")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[read]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Picture")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[view]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Presentation")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[see]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Audio")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[listen]".
							"</a>\n";
					else
						echo "<a href=".stripslashes($ro2[2]).">".
							"[watch]".
							"</a>\n";
					
					} /* end while looping through associated files */
				if($showsynopsis == 1)
					echo "<br />\n$synopsis\n";
	

				if($showtexts == 1)
					{
					echo "<br />(Text: ";
					$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
						"WHERE sermonid='$sermonid'";
					$re2 = sql_getresult($q2);
					if($ro2 = sql_getrow($re2)) 
						echo "<a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					while($ro2 = sql_getrow($re2))
						echo ", <a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					echo ")\n";
					} /* end if showtexts */
	
				if(($showtexts == 1) OR ($showsynopsis == 1)) echo "<br />\n";

				echo "</li>\n";
				} /* end if authorized */
			} /* end while looping through sermons */
		echo "</ul></p>\n";
		} /* end while looping through topics */
	} /* end if sorting by most recent sermon */

if($sort1 == "Oldest")
	{
	/* First get all the topics and sort them */
	$last = "";
	$q1 = "SELECT ls_sermon_topics.id,topic FROM ls_sermon_topics,ls_sermons ".
		"WHERE ls_sermons.id = ls_sermon_topics.sermonid AND published>'0' ORDER BY topic ASC";
	$re1 = sql_getresult($q1);
	while($ro1 = sql_getrow($re1))
		{
		/* skip duplicates */
		if($ro1[1] == $last) continue;
		$last = $ro1[1];

		/* $i will be where we insert this topic */
		/* $j will be the topic we're currently comparing him to */
		$i = count($topics);
		for($j=count($topics)-1;$j>=0;$j--)
			{
			if(sql_getone("SELECT sermondate FROM $dbtable,ls_sermon_topics ".
					"WHERE topic='$ro1[1]' AND ".
					"$dbtable.id=ls_sermon_topics.sermonid AND published>0 ".
					"ORDER BY sermondate ASC") <
				sql_getone("SELECT sermondate FROM $dbtable,ls_sermon_topics ".
					"WHERE topic='$topics[$j]' AND ".
					"$dbtable.id=ls_sermon_topics.sermonid AND published>0 ".
					"ORDER BY sermondate ASC"))
				{
				$topics[$i] = $topics[$j];
				$i = $j;
				}
			} /* end while looping through topics to sort */
		$topics[$i] = $ro1[1];
		} /* end while looping through topics */
	for($i=0;$i < count($topics);$i++)
		{
		echo "<p style=\"font-weight: bold;\">".stripslashes($topics[$i])."\n";
		echo "<ul>\n"; /* could use CSS to style this list */
		$query = "SELECT $dbtable.id,title,sermondate,pastor,synopsis ".
				"FROM $dbtable,ls_sermon_topics ".
				"WHERE topic='$topics[$i]' AND $dbtable.id=sermonid AND published>0 ".
				"ORDER BY sermondate DESC";
		$result = sql_getresult($query);
		while($row=sql_getrow($result))
			{
			if(check_auth($thisuser,$objecttype,$row[0],$LS_USER_THRESHOLD))
				{
				$sermonid = $row[0];
				$title = stripslashes($row[1]);
				$pastor = stripslashes(sql_getone("SELECT fullname FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				$bio = stripslashes(sql_getone("SELECT bio FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				if(strlen($bio) > 0) $pastor = "<a href=$bio>$pastor</a>";
				$date = date("F j, Y",strtotime($row[2]));
				$synopsis = stripslashes($row[4]);
	
				echo "<li><b>$title</b> ($pastor, $date) ";
				/* now find all attachments */
				$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
					"WHERE sermonid='$sermonid'";
				$re2 = sql_getresult($q2);
				while($ro2 = sql_getrow($re2))
					{
					if(stripslashes($ro2[1]) == "Text/PDF")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[read]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Picture")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[view]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Presentation")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[see]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Audio")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[listen]".
							"</a>\n";
					else
						echo "<a href=".stripslashes($ro2[2]).">".
							"[watch]".
							"</a>\n";
					
					} /* end while looping through associated files */
				if($showsynopsis == 1)
					echo "<br />\n$synopsis\n";
	
				if($showtexts == 1)
					{
					echo "<br />(Text: ";
					$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
						"WHERE sermonid='$sermonid'";
					$re2 = sql_getresult($q2);
					if($ro2 = sql_getrow($re2)) 
						echo "<a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					while($ro2 = sql_getrow($re2))
						echo ", <a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					echo ")\n";
					} /* end if showtexts */
	
				if(($showtexts == 1) OR ($showsynopsis == 1)) echo "<br />\n";

	
				echo "</li>\n";
				} /* end if authorized */
			} /* end while looping through sermons */
		echo "</ul></p>\n";
		} /* end while looping through topics */
	} /* end if sorting by earliest sermon */

if($sort1 == "Alphabetical")
	{
	/* First get all the topics and sort them */
	$last = "";
	$q1 = "SELECT ls_sermon_topics.id,topic FROM ls_sermon_topics,ls_sermons ".
		"WHERE ls_sermons.id = ls_sermon_topics.sermonid AND published>'0' ORDER BY topic ASC";
	$re1 = sql_getresult($q1);
	while($ro1 = sql_getrow($re1))
		{
		/* skip duplicates */
		if($ro1[1] == $last) continue;
		$last = $ro1[1];

		/* $i will be where we insert this topic */
		/* $j will be the topic we're currently comparing him to */
		$i = count($topics);
		$topics[$i] = $ro1[1];
		} /* end while looping through topics */
	for($i=0;$i < count($topics);$i++)
		{
		echo "<p style=\"font-weight: bold;\">".stripslashes($topics[$i])."\n";
		echo "<ul>\n"; /* could use CSS to style this list */
		$query = "SELECT $dbtable.id,title,sermondate,pastor,synopsis ".
				"FROM $dbtable,ls_sermon_topics ".
				"WHERE topic='$topics[$i]' AND $dbtable.id=sermonid AND published>0 ".
				"ORDER BY sermondate DESC";
		$result = sql_getresult($query);
		while($row=sql_getrow($result))
			{
			if(check_auth($thisuser,$objecttype,$row[0],$LS_USER_THRESHOLD))
				{
				$sermonid = $row[0];
				$title = stripslashes($row[1]);
				$pastor = stripslashes(sql_getone("SELECT fullname FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				$bio = stripslashes(sql_getone("SELECT bio FROM ls_pastors ".
							"WHERE id='$row[3]'"));
				if(strlen($bio) > 0) $pastor = "<a href=$bio>$pastor</a>";
				$date = date("F j, Y",strtotime($row[2]));
				$synopsis = stripslashes($row[4]);
	
				echo "<li><b>$title</b> ($pastor, $date) ";
				/* now find all attachments */
				$q2 = "SELECT id,uploadtype,uploadurl FROM ls_sermon_files ".
					"WHERE sermonid='$sermonid'";
				$re2 = sql_getresult($q2);
				while($ro2 = sql_getrow($re2))
					{
					if(stripslashes($ro2[1]) == "Text/PDF")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[read]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Picture")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[view]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Presentation")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[see]".
							"</a>\n";
					elseif(stripslashes($ro2[1]) == "Audio")
						echo "<a href=".stripslashes($ro2[2]).">".
							"[listen]".
							"</a>\n";
					else
						echo "<a href=".stripslashes($ro2[2]).">".
							"[watch]".
							"</a>\n";
					
					} /* end while looping through associated files */
				if($showsynopsis == 1)
					echo "<br />\n$synopsis\n";

				if($showtexts == 1)
					{
					echo "<br />(Text: ";
					$q2 = "SELECT scripturetext FROM ls_sermon_texts ".
						"WHERE sermonid='$sermonid'";
					$re2 = sql_getresult($q2);
					if($ro2 = sql_getrow($re2)) 
						echo "<a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					while($ro2 = sql_getrow($re2))
						echo ", <a href='$bibleurl".
							urlencode(stripslashes($ro2[0])).
							"'>".stripslashes($ro2[0])."</a>";
					echo ")\n";
					} /* end if showtexts */
	
				if(($showtexts == 1) OR ($showsynopsis == 1)) echo "<br />\n";

	
				echo "</li>\n";
				} /* end if authorized */
			} /* end while looping through sermons */
		echo "</ul></p>\n";
		} /* end while looping through topics */
	} /* end if sorting topics alphabetically */

?>
</form>
<p style="font-weight: bold;font-size: 18pt;">Search Sermons</p>
<?php/********************************************************************/
/*     If the search form is somewhere else, change this address         */
/*************************************************************************/?>
<form method=GET action="ls_search_sermons.php">
<input type=text name=q size=30><input type=submit value="Search">
</form>
<br />
<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>